config/routes.rb
# frozen_string_literal: true
Rails.application.routes.draw do
  resources :organizations

  resources :organizations, only: [] do
    resources :item_types do
      get 'graph_map', controller: 'states'
    end

    resources :item_types, only: [], path: '' do
      match 'summary', to: 'item_types#summary', via: :get
      resources :states
      resources :items, path: ''
    end
  end

  root 'home#index'
  match 'home/private_index' => 'home#private_index', via: :get

  # omniauth
  get '/auth/:provider/callback' => 'user_sessions#create'
  get '/auth/failure' => 'user_sessions#failure'
  get 'auth/autologin' => 'user_sessions#autologin'

  # Custom logout
  match '/logout', to: 'user_sessions#destroy', via: :all
end

app/models/organization.rb
# frozen_string_literal: true
class Organization < ApplicationRecord
  # t.string   "name",       null: false
  # t.datetime "created_at", null: false
  # t.datetime "updated_at", null: false
  # t.index ["name"], name: "index_organizations_on_name", unique: true, using: :btree

  # validations
  validates :name, presence: true, uniqueness: true

  # relations
  has_many :item_types, dependent: :restrict_with_exception
end

app/controllers/organizations_controller.rb
# frozen_string_literal: true
class OrganizationsController < ApplicationController
  before_action :set_organization, only: [:show, :edit, :update, :destroy]

  # GET /organizations
  # GET /organizations.json
  def index
    @organizations = Organization.all
  end

  # GET /organizations/1
  # GET /organizations/1.json
  def show; end

  # GET /organizations/new
  def new
    @organization = Organization.new
  end

  # GET /organizations/1/edit
  def edit; end

  # POST /organizations
  # POST /organizations.json
  def create
    @organization = Organization.new(organization_params)

    respond_to do |format|
      if @organization.save
        format.html do
          redirect_to @organization,
                      notice: 'Organization was successfully created.'
        end
        format.json { render :show, status: :created, location: @organization }
      else
        format.html { render :new }
        format.json { render json: @organization.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /organizations/1
  # PATCH/PUT /organizations/1.json
  def update
    respond_to do |format|
      if @organization.update(organization_params)
        format.html do
          redirect_to @organization,
                      notice: 'Organization was successfully updated.'
        end
        format.json { render :show, status: :ok, location: @organization }
      else
        format.html { render :edit }
        format.json { render json: @organization.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /organizations/1
  # DELETE /organizations/1.json
  def destroy
    @organization.destroy
    respond_to do |format|
      format.html do
        redirect_to organizations_url,
                    notice: 'Organization was successfully destroyed.'
      end
      format.json { head :no_content }
    end
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_organization
    @organization = Organization.find(params[:id])
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def organization_params
    params.require(:organization).permit(:name)
  end
end

app/helpers/organizations_helper.rb
# frozen_string_literal: true
module OrganizationsHelper
end

app/views/organizations/_form.html.haml
= form_for organization do |f|
  - if organization.errors.any?
    #error-explanation
      %h2
        = pluralize(organization.errors.count, 'error')
        prohibited this organization from being saved:
      %ul
        - organization.errors.full_messages.each do |msg|
          %li= msg

  .field
    = f.label :name
    = f.text_field :name
  .actions
    = f.submit 'Save'

app/views/organizations/edit.html.haml
%h1 Editing organization

= render 'form', organization: @organization

= link_to 'Show', @organization
\|
= link_to 'All organizations', organizations_path

app/views/organizations/index.html.haml
%p#alert= alert

%h1 Listing organizations

%table
  %thead
    %tr
      %th Name
      %th
      %th
      %th

  %tbody
    - @organizations.each do |organization|
      %tr
        %td= organization.name
        %td= link_to 'Show', organization
        %td= link_to 'Edit', edit_organization_path(organization)
        %td= link_to 'Destroy', organization,
        method: :delete, data: { confirm: 'Are you sure?' }

%br

-# = link_to 'New Organization', new_organization_path

app/views/organizations/new.html.haml
%h1 New organization

= render 'form', organization: @organization

= link_to 'All organizations', organizations_path

app/views/organizations/show.html.haml
%p#notice= notice

%h1= @organization.name
%h2 Number of item types: #{@organization.item_types.count}

= link_to 'All Item Types', organization_item_types_path(@organization)
%br
- if current_user.present?
  = link_to 'Edit organization', edit_organization_path(@organization)
  \|
= link_to 'All organizations', organizations_path